//PROFILE-NO
unit NProfCalibra;
interface

USES
  Borland.Vcl.Windows;
// Do not change these settings !!!
{$O-}
{$D-}
{$Q-}
{$R-}
{$B-}
{$I-}
{$J-}
{$T+}
PROCEDURE NCalcQPCTime802;

IMPLEMENTATION
USES
  NProfInt;

// Calibration - Functions - DO NOT USE
PROCEDURE NProfOpenCalcQPCTime;                         external 'NPROFMEA.DLL';
PROCEDURE NProfCloseCalcQPCTime;                        external 'NPROFMEA.DLL';
FUNCTION  NProfCPUTick : Int64;                         stdcall;  external 'NPROFMEA.DLL';
PROCEDURE NProfResetSingleRuntime ( Index : Integer );  stdcall;  external 'NPROFMEA.DLL';
PROCEDURE NProfSetThreadKorr ( Zeit : LongInt );        stdcall; external 'NPROFMEA.DLL';
PROCEDURE NProfSetStopKorrExit ( zeit : Integer );      stdcall; external 'NPROFMEA.DLL';
FUNCTION  NProfGetSingleRuntime ( Index : Integer ) : Int64; stdcall; stdcall; external 'NPROFMEA.DLL';


FUNCTION MinimumNull ( a, b : INT64 ) : INT64;
BEGIN
  IF a > b THEN
    Result := b
  ELSE
    Result := a;
  IF b < 0 THEN Result := a;
END;

PROCEDURE Func6;
BEGIN
  NProfStop;
  Try;
    NProfEnter(6);
  finally;
    NProfExit(6);
  end;
END;

PROCEDURE Func5;
BEGIN
  NProfStop;
  Try;
    NProfEnter(5);
    Func6;
  finally;
    NProfExit(5);
  end;
END;

FUNCTION MeasureTotalRuntime(VAR RT6 : Int64) : Int64;
VAR
  i        : Integer;
  ta       : Int64;
  te       : Int64;
BEGIN
  Result    := 100000000;
  NProfResetSingleRuntime(6);
  NProfResetSingleRuntime(5);
  RT6 := 100000000;
  FOR i := 1 TO 100 DO BEGIN
    ta  := NProfCPUTick;
    Func5;
    te     := NProfCPUTick - ta;
    Result := MinimumNull(Result, te);
    te     := NProfGetSingleRuntime( 6 );
    RT6    := MinimumNull(RT6, te);
    NProfResetSingleRuntime(6);
    NProfResetSingleRuntime(5);
  END;
END;

PROCEDURE NCalcQPCTime802;
VAR
  tk  : Integer;
  RT6 : Int64;
BEGIN
  NProfOpenCalcQPCTime;
  tk := MeasureTotalRuntime( RT6 );
  NProfSetThreadKorr(tk);
  NProfSetStopKorrExit( RT6 );
  NProfCloseCalcQPCTime;
END;

END.
